#!/bin/sh
# ----------------------------- CIMEC-INTEC ----------------------------------- 
# ------- Centro Internacional de Metodos Computacionales en Ingeniería -------
# -------- (International Center for Numerical Methods in Engineering) --------  
# ----------------------- Santa Fe - Argentina --------------------------------
#
#    License
#
#    OpenFOAM is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 2 of the License, or (at your
#    option) any later version.
#
#    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with OpenFOAM; if not, write to the Free Software Foundation,
#    Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
#
# Created By:
# J.M. Gimenez(1), S.Marquez Damian(1), N. Nigro(1)
#
# (1)CIMEC (INTEC-UNL-CONICET), Santa Fe, Argentina
#
# (1)CIMEC (INTEC-UNL-CONICET), Santa Fe, Argentina
#
#
# contact: jmarcelogimenez@gmail.com
#
# Description:
#	Manage the vol*Fields dumping.
# ----------------------------------------------------------------------------------------

if [ $1 = "folder_name" ];
then
	ls -F | grep "/" | grep "\(^[0-9]*\/$\|^[0-9]*\.[0-9]*\/$\|^[0-9]*e-\?[0-9]*\/$\|^[0-9]*\.[0-9]*e-\?[0-9]*\/$\)" | cut -d "/" -f1 | tr -s "." "," | sort -g | tr -s "," "." > folder_name
	mv -f folder_name aux
	tail -n1 aux > folder_name
	rm aux
fi
if [ $1 = "make_dirs" ];
then
	if [ ! -d "gdbOF_dump" ];
	then
		mkdir gdbOF_dump
	fi
	cut -d '"' -f 2 -s time_aux > aux
	mv -f aux time_aux
	time=`cat time_aux`
	direc='gdbOF_dump/'$time
	if [ ! -d $direc ];
	then
		mkdir $direc
	fi
	echo $direc > direc_name 
fi
if [ $1 = "include_dim" ];
then			
	aux=`cut -d "=" -f 2 -s dim_aux | tr -s "},{" " "`
	sed -e "s/DIM/$aux/g" < ~/OpenFOAM/gdbOF/base_field.foam > aux
	mv aux auxDump.foam
	rm dim_aux
fi
if [ $1 = "include_class" ];
then			
	aux=`cut -d '"' -f 2 -s  class_aux`
	sed -e "s/CLASS/$aux/g" < auxDump.foam > aux
	mv aux auxDump.foam
	rm class_aux
fi
if [ $1 = "include_object" ];
then			
	aux=`cut -d '"' -f 2 -s object_aux`
	sed -e "s/OBJECT/$aux/g" < auxDump.foam > aux
	echo $aux > field_name
	mv aux auxDump.foam
	rm object_aux
fi
if [ $1 = "include_version" ];
then			
	sed -e "s/VERSION/$WM_PROJECT_VERSION/g" < auxDump.foam > aux
	mv aux auxDump.foam
fi
if [ $1 = "include_iv" ];
then		
	size=`wc -l < piv_aux`
	sed -e "s/INTERNALSIZE/$size/g" < auxDump.foam > aux
	mv aux auxDump.foam

	sed -e "s/INTERNALTYPE/$2/g" < auxDump.foam > aux
	mv aux auxDump.foam
	
	if [ $2 = "scalar" ];
	then
		head -n 21 auxDump.foam > auxH
	else
		head -n 21 auxDump.foam > auxH
		sed -e 's/^/(/g' piv_aux | sed -e 's/$/)/g' > piv_aux2
		mv piv_aux2 piv_aux
	fi	
	cat auxH piv_aux > auxDump.foam
	echo ");" >> auxDump.foam
	echo "\r" >> auxDump.foam
	echo "boundaryField" >> auxDump.foam
	echo "{" >> auxDump.foam
	rm piv_aux
	rm auxH
fi
if [ $1 = "include_pv" ];
then		
	name=`cut -d '"' -f 2 -s  bouName_aux`
	type=`cut -d '"' -f 2 -s  bouType_aux`
	rm bouName_aux
	rm bouType_aux
	if [ $type = "empty" -o $type = "wedge" -o $type = "zeroGradient" ];
	then
		sed -e "s/BOUNDARYNAME/$name/g" < ~/OpenFOAM/gdbOF/base_boundary1.foam > auxBouDump.foam
		sed -e "s/BOUNDARYTYPE/$type/g" < auxBouDump.foam > auxi
		mv auxi auxBouDump.foam
		cat auxDump.foam auxBouDump.foam > aux
		mv aux auxDump.foam
		rm auxBouDump.foam
	else
		size=`wc -l < ppv_aux`
		sed -e "s/BOUNDARYSIZE/$size/g" < ~/OpenFOAM/gdbOF/base_boundary2.foam > auxBouDump.foam
		sed -e "s/BOUNDARYNAME/$name/g" < auxBouDump.foam > aux
		mv aux auxBouDump.foam	
		#sed -e "s/BOUNDARYTYPE/$type/g" < auxBouDump.foam > aux
		sed -e "s/BOUNDARYTYPE/fixedValue/g" < auxBouDump.foam > aux
		mv aux auxBouDump.foam	
		sed -e "s/BOUNDARYFORMAT/$2/g" < auxBouDump.foam > aux
		mv aux auxBouDump.foam
	
		if [ $2 = "scalar" ];
		then
			head -n 6 auxBouDump.foam > auxH
		else
			head -n 6 auxBouDump.foam > auxH
			sed -e 's/^/(/g' ppv_aux | sed -e 's/$/)/g' > ppv_aux2
			mv ppv_aux2 ppv_aux
		fi	
		cat auxH ppv_aux > auxBouDump.foam
		echo ");" >> auxBouDump.foam
		echo "}" >> auxBouDump.foam
		cat auxDump.foam auxBouDump.foam > aux
		mv aux auxDump.foam
		rm ppv_aux auxBouDump.foam auxH
	fi
fi
if [ $1 = "finalize" ];
then		
	echo "}" >> auxDump.foam
	echo "\r" >> auxDump.foam
	echo "// ************************************************************************* //" >> auxDump.foam
	direc=`cat direc_name`
	field=`cat field_name`
	time=`cat time_aux`
	counter=`ls $direc/$field* 2> /dev/null | sort -g | tail -n1 | cut -d '/' -f3 | cut -d '.' -f2 | cut -d '/' -f1`
	if [ -z "$counter"  ];
	then	
		counter=0
	else
		counter=`expr $counter + 1`
	fi
	mv auxDump.foam $direc/$field.$counter.dump
	cd gdbOF_dump
	ln -s ../system system 2> /dev/null
	ln -s ../constant constant 2> /dev/null
	cd ..
	rm direc_name
	echo $field.$counter.dump > field_name

fi
if [ $1 = "VTK" ];
then	
	sed -e 's/^/(/g' field_name | sed -e 's/$/)/g' > field_name2
	field=`cat field_name2`
	time=`cat time_aux`
	cd gdbOF_dump
	echo "Exporting to VTK..."
	foamToVTK -time $time -fields $field > foamToVTK.log  
	cd ..
fi
if [ $1 = "Paraview" ];
then		
	cd gdbOF_dump
	echo "Launching Paraview..."
	paraview --data=VTK/gdbOF_dump_0.vtk &
	cd ..
fi
if [ $1 = "clean" ];
then		
	rm  field_name field_name2 time_aux ppv_aux 2> /dev/null
fi
